/*  fork+write.c (Praktikum, Arbeitsblatt 4)

    Vorlesung Betriebssysteme
    Hans-Georg Esser, FOM Muenchen
    h.g.esser@gmx.de
*/

int syscall (int eax, int ebx, int ecx, int edx) {
  int result ;
  asm ( 
    "int $0x80" 
    : "=a" (result)
    : "a" (eax), "b" (ebx), "c" (ecx), "d" (edx)
  );
  return result ;
}

int main() {
  char vater[]="Ich bin der Vater.\n";
  int vlen=sizeof(vater);
  char sohn[]="Ich bin der Sohn.\n";
  int slen=sizeof(sohn);

  int pid=fork();

  if (pid) {
    write(1,&vater,vlen,0);
  }
  else {
    write(1,&sohn,slen,0);
  }
  return 0;
}

